#  Copyright (c) 1997-2011
#  Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Darmstadt, Germany)
#  http://www.polymake.de
#
#  This program is free software; you can redistribute it and/or modify it
#  under the terms of the GNU General Public License as published by the
#  Free Software Foundation; either version 2, or (at your option) any
#  later version: http://www.gnu.org/licenses/gpl.txt.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#-------------------------------------------------------------------------------
#  $Project: polymake $$Id: nativelib.make 10520 2011-12-25 14:47:12Z gawrilow $

#  Building a native methods library (for Java JNI)

AppName ?= $(notdir ${CURDIR})
AppTop ?= ${ProjectTop}
SourceTop := $(firstword ${ExtensionTop} ${AppTop})
SourceDir := ${SourceTop}/apps/${AppName}/src

ARCHFLAGS := ${NativeArchFlags}

Includes += ${JNI_HEADERS} $(dir $(wildcard ${JNI_HEADERS}/*/jni_md.h))
withInclude := ${ProjectTop}/java_build/jni/${AppName}.h

broken := $(patsubst ${SourceDir}/%,%,$(call _get_no_export,${SourceDir}/native,broken))

SharedModules := $(basename $(filter-out ${broken}, $(call _list_C_sources,${SourceDir},native)))
SharedObjects := $(addsuffix $O, ${SharedModules})

SourceSubdirs := native

OwnShared := ${BuildDir}/lib/jni/lib${AppName}$(subst bundle,jnilib,$S)

${OwnShared} : ${SharedObjects}
	@mkdir -p ${BuildDir}/lib/jni
	${CC} ${LDsharedFlags} -o $@ $^ ${LDFLAGS}

compile-native : ${OwnShared}

install-native : compile-native
	${PERL} ${INSTALL_PL} -d -m ${DirMask} ${InstallArch}/lib/jni
	${PERL} ${INSTALL_PL} -m 555 ${OwnShared} ${InstallArch}/lib/jni

clean::
	rm -f ${OwnShared}

ProcessDep := n
